=== debian/changelog ===
dolphin-emu (2412+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Update DOLPHIN_WC_DESCRIBE and DOLPHIN_WC_REVISION.

 -- Jordi Mallach <jordi@debian.org>  Wed, 04 Dec 2024 00:07:42 +0100
